const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const lots = sequelize.define(
    'lots',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

lot_number: {
        type: DataTypes.TEXT,
      
      

      },

manufactured_at: {
        type: DataTypes.DATE,
      
      

      },

expires_at: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"available",


"quarantined",


"expired",


"consumed"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  lots.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























    db.lots.hasMany(db.inventory_transfer_lines, {
      as: 'inventory_transfer_lines_lot',
      foreignKey: {
          name: 'lotId',
      },
      constraints: false,
    });


    db.lots.hasMany(db.stock_movements, {
      as: 'stock_movements_lot',
      foreignKey: {
          name: 'lotId',
      },
      constraints: false,
    });






    db.lots.hasMany(db.sales_allocations, {
      as: 'sales_allocations_lot',
      foreignKey: {
          name: 'lotId',
      },
      constraints: false,
    });





    db.lots.hasMany(db.customer_return_lines, {
      as: 'customer_return_lines_lot',
      foreignKey: {
          name: 'lotId',
      },
      constraints: false,
    });





    db.lots.hasMany(db.receipt_lines, {
      as: 'receipt_lines_lot',
      foreignKey: {
          name: 'lotId',
      },
      constraints: false,
    });



















//end loop



    db.lots.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.lots.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.lots.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.lots.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.lots.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return lots;
};


